#include "testlib.h"
#include <vector>
using namespace std;

int validate(int n, vector<int>& finish, InStream& stream) {
  int m = stream.readInt(0, 1000000, "number of overtakes");

  vector<int> current(n);
  vector<int> where(n + 1);
  for (int i = 1; i <= n; i++) {
    current[i - 1] = i;
    where[i] = i - 1;
  }
  vector<vector<bool>> seen;
  for (int i = 0; i <= n; i++)
    seen.emplace_back(n + 1, false);

  for (int i = 0; i < m; i++) {
    int x = stream.readInt(1, n, "car number");
    int y = stream.readInt(1, n, "car number");
    if (x == y)
      stream.quitf(_wa, "car %d overtook itself\n", x);
    if (seen[x][y])
      stream.quitf(_wa, "has already seen the pair %d->%d\n", x, y);
    int px = where[x];
    int py = where[y];
    if (px != py + 1)
      stream.quitf(_wa, "cars %d and %d are not adjacent, being in %d and %d place\n", x, y, px, py);
    seen[x][y] = 1;
    swap(current[px], current[py]);
    where[x] = py;
    where[y] = px;
  }

  for (int i = 0; i < n; i++) {
    if (current[i] != finish[i])
      stream.quitf(_wa, "car %d is in the wrong place\n", current[i]);
  }

  return m;
}

int main(int argc, char* argv[]) {
  registerTestlibCmd(argc, argv);

  int n = inf.readInt(1, 1000, "number of cars");
  vector<int> finish = inf.readInts(n, 1, n, "finish order");

  int jury = validate(n, finish, ans);
  int participant = validate(n, finish, ouf);

  if (jury < participant)
    quitf(_fail, "participant has a better answer: jury = %d, participant = %d\n", jury, participant);
  else if (jury > participant)
    quitf(_wa, "jury has a better answer: jury = %d, participant = %d\n", jury, participant);
  else
    quitf(_ok, "answer = %d\n", jury);
}
