# Generates correct solution for numbers < 256

io_word = 0x0fff
io_addr = io_word * 16
end = 0xfff

def instruction(ip, a, b, c = None):
    if c == None:
        c = ip + 3

    assert 0 <= a < 2 ** 16
    assert 0 <= b < 2 ** 16
    assert 0 <= c < 2 ** 16

    program[ip + 0] = a
    program[ip + 1] = b
    program[ip + 2] = c


program = [0] * (1024 * 3)

dispatch1 = 8 * 6
dispatch2 = dispatch1 + 3
success = dispatch2 + 3
fail = success + 3
for i in range(8):
    instruction(i * 6 + 0, io_addr + i    , (dispatch1 + 2) * 16 + i + 2)
    instruction(i * 6 + 3, io_addr + i + 8, (dispatch2 + 2) * 16 + i + 2)

instruction(dispatch1, 0, 0, 1024)
instruction(dispatch2, 0, 0, 2048)
instruction(success  , (dispatch1 + 2) * 16 + 10, io_addr, end)
instruction(fail     , (dispatch1 + 2) * 16 + 11, io_addr, end)


k = int(input())

for i in range(256):
    instruction(1024 + i * 4, 0, 0, dispatch2 if i == k & 0xff else fail)
    instruction(2048 + i * 4, 0, 0, success   if i == 0 else fail)

for w in program:
    print(f'{w:04x} ', end='')
