#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

const int N = 100005;

vector < pair<int, int> > edges;
int deg[N];

inline int readAndCheckAnswer(InStream& in, int n) {
  vector < set<int> > d(n + 1);

  string s = in.readToken("YES|NO", "Existence of solution");

  if (s == "NO") {
    return -1;
  }

  int colors = in.readInt(1, (int)edges.size(), "The total labels");
  set <int> all_colors;

  for (int i = 0; i < (int)edges.size(); i++) {
    int a = edges[i].first;
    int b = edges[i].second;

    int c = in.readInt(1, colors, format("Label of the %d-th edge", i));

    d[a].insert(c);
    d[b].insert(c);

    all_colors.insert(c);
  }

  if ((int)all_colors.size() != colors) {
    in.quitf(_wa, "The given labeling is invalid since not all labels are used");
  }

  for (int i = 1; i <= n; i++) {
    if ((int)d[i].size() != deg[i]) {
      in.quitf(_wa, "The vertex %d has two incident edges with the same label", i);
    }

    int min_label = *d[i].begin();
    int max_label = *d[i].rbegin();
    if (max_label - min_label + 1 != deg[i]) {
      in.quitf(_wa, "The labels of edges incident to the vertex %d are not consequtive integers", i);
    }
  }

  return 1;
}

int main(int argc, char* argv[]) {
  registerTestlibCmd(argc, argv);

  int n = inf.readInt(3, 100'000, "n");
  int m = inf.readInt(n, 3 * (n - 1) / 2, "m");

  for (int i = 0; i < m; i++) {
    int a = inf.readInt(1, n, "a");
    int b = inf.readInt(1, n, "b");
    //
    deg[a]++;
    deg[b]++;
    //
    edges.emplace_back(a, b);
  }

  int jury = readAndCheckAnswer(ans, n);
  int participant = readAndCheckAnswer(ouf, n);

  if (jury != -1 && participant == -1) {
    quitf(_wa, "Jury has the answer but participant has not");
  }
  if (jury == -1 && participant != -1) {
    quitf(_fail, "Participant has the answer but jury has not");
  }

  quitf(_ok, "OK");
  return 0;
}
