#include <bits/stdc++.h>
#include "testlib.h"
 
using namespace std;

const int N = 100005;

vector <int> g[N];

bool used[N];
map <int, bool> mark[N];
int parent[N];

vector <int> odd_cycle_lengths;

bool dfs(int v, int p) {
  used[v] = true;

  for (auto to: g[v]) {
    if (to == p || mark[v].contains(to)) continue;

    if (used[to]) {
      mark[v][to] = mark[to][v] = true;

      int gag = v, len = 1;
      while (gag != to) {
        ++len;
        int papa = parent[gag];
        if (mark[papa][gag]) {
          return false;
        }
        mark[papa][gag] = mark[gag][papa] = true;
        gag = papa;
      }

      if (len % 2) {
        odd_cycle_lengths.push_back(len);
      }
      continue;
    }

    parent[to] = v;
    bool flag = dfs(to, v);
    if (!flag) return false;
  }

  return true;
}

bool is_graph_cactus(int n) {
  bool flag = dfs(1, -1);

  // check whether the graph is connected
  for (int i = 1; i <= n; i++) {
    if (!used[i]) {
      flag = false;
      break;
    }
  }

  return flag;
}
 
int main(int argc, char *argv[]) {
  registerValidation(argc, argv);

  int n = inf.readInt(3, 100'000, "n");
  inf.readSpace();
  int m = inf.readInt(n, 3 * (n - 1) / 2, "m");
  inf.readEoln();

  map < pair<int, int>, bool > exist;

  for (int i = 1; i <= m; i++) {
    int a = inf.readInt(1, n, format("a[%d]", i));
    inf.readSpace();
    int b = inf.readInt(1, n, format("b[%d]", i));
    inf.readEoln();

    if (a > b) swap(a, b);

    ensuref(a != b, "The given graph should not contain loops");
    ensuref(exist.find(make_pair(a, b)) == exist.end(), "The given graph should not contain multiple edges");

    exist[make_pair(a, b)] = true;

    g[a].push_back(b);
    g[b].push_back(a);
  }

  ensuref(is_graph_cactus(n), "The given graph should be a cactus");

  int total_odd_cycles = (int)odd_cycle_lengths.size();
  for (int len: odd_cycle_lengths) {
    ensuref(len >= total_odd_cycles, "The length of each odd simple cycle should be greater than or equal to the number of odd simple cycles in the cactus");
  }

  for (int i = 1; i <= n; i++) {
    for (int to: g[i]) {
      ensuref(mark[i][to], "Cactus should be without bridges");
    }
  }

  inf.readEof();
  return 0;
}
