#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
//#define int long long

#define all(v) (v).begin(), (v).end()
#define db(x) cerr << #x << " = " << x << '\n'
#define mp make_pair
#define eb emplace_back
#define pb push_back
#define sz(v) (int)((v).size())
#define pw(x) (1LL << (int)(x))
#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define fe(x, y) for(auto &x : y)

mt19937_64  rng(566);

ll rnd(ll l, ll r) {
    return rng() % (r - l + 1) + l;
}

template <typename T>
bool umn(T &a, T b) {
    return a > b ? a = b, 1 : 0;
}

template <typename T>
bool umx(T &a, T b) {
    return a < b ? a = b, 1 : 0;
}

template <typename T>
using ve = vector<T>;

const ld eps = 1e-8;
const ll mod = 1e9 + 7;
const int inf0 = 1e9 + 10;
const ll inf = 2e18 + 10;

bool is_cyclic(int v, int p, const ve<ve<int>> &graph, ve<int> &color, ve<int> &tout, int &tit) {
    if (color[v] == 1) return true;
    color[v] = 1;
    for (int u : graph[v]) {
        if (u == p) continue;
        if (color[u] == 2) continue;
        if (is_cyclic(u, v, graph, color, tout, tit)) return true;
    }
    tout[v] = tit++;
    color[v] = 2;
    return false;
}

ve<int> get_topsort(const ve<ve<int>> &graph) {
    int n = graph.size();
    ve<int> tout(n), color(n, 0);
    int tit = 0;
    for (int i = 0; i < n; ++i) {
        if (color[i] == 2) continue;
        if (is_cyclic(i, -1, graph, color, tout, tit)) return {};
    }
    ve<pair<int, int>> ordered(n);
    for (int i = 0; i < n; ++i) ordered[i] = {tout[i], i};
    sort(all(ordered));
    ve<int> ans(n);
    for (int i = 0; i < n; ++i) ans[i] = ordered[i].second;
    reverse(all(ans));
    return ans;
}

void solve();

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

void solve() {
    int n;
    cin >> n;
    vector<bool> is_unset_false(n, false), is_set_false(n, false);
    int set_true_id = -1, unset_true_id = -1;
    for (int i = 0; i < n; ++i) {
        string a, b;
        cin >> a >> b;
        if (a == "set") {
            if (b == "true") {
                set_true_id = i;
            } else {
                is_set_false[i] = true;
            }
        } else {
            if (b == "true") {
                unset_true_id = i;
            } else {
                is_unset_false[i] = true;
            }
        }
    }
    int m;
    cin >> m;
    ve<ve<int>> graph(n);
    ve<int> count_incoming(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        graph[a].emplace_back(b);
        count_incoming[b]++;
    }
    if (unset_true_id != -1 && set_true_id == -1) {
        cout << -1 << '\n';
        return;
    }
    ve<int> category(n, -1);
    deque<int> freee;
    ve<int> order;
    for (int i = 0; i < n; ++i) {
        if (count_incoming[i] == 0 && is_unset_false[i]) {
            freee.emplace_back(i);
        }
    }
    while (!freee.empty()) {
        int v = freee.front();
        freee.pop_front();
        category[v] = 0;
        order.eb(v);
        for (int u : graph[v]) {
            count_incoming[u]--;
            if (is_unset_false[u]) {
                if (count_incoming[u] == 0) {
                    freee.emplace_back(u);
                }
            }
        }
    }
    if (set_true_id != -1 && unset_true_id != -1) {
        graph[set_true_id].eb(unset_true_id);
    }
    if (set_true_id == -1) {
        if (sz(order) != n) {
            cout << "-1\n";
            return;
        }
        for (auto e : order) {
            cout << e + 1 << ' ';
        }
        cout << '\n';
        return;
    }
    if (count_incoming[set_true_id] > 0) {
        cout << "-1\n";
        return;
    }
    order.eb(set_true_id);
    category[set_true_id] = -2;
//    for (int i = 0; i < n; ++i) {
//        if (category[i] == 0) {
//            graph[i].emplace_back(set_true_id);
//        }
//    }
    for (int u : graph[set_true_id]) {
        count_incoming[u]--;
    }
    for (int i = 0; i < n; ++i) {
        if (is_set_false[i] && count_incoming[i] == 0) {
            freee.eb(i);
        }
    }
    while (!freee.empty()) {
        int v = freee.front();
        freee.pop_front();
        category[v] = 1;
        order.eb(v);
        for (int u : graph[v]) {
            count_incoming[u]--;
            if (is_set_false[u]) {
                if (count_incoming[u] == 0) {
                    freee.emplace_back(u);
                }
            }
        }
    }
    if (unset_true_id == -1) {
        if (sz(order) != n) {
            cout << "-1\n";
            return;
        }
        for (auto e : order) {
            cout << e + 1 << ' ';
        }
        cout << '\n';
        return;
    }
    if (count_incoming[unset_true_id] > 0) {
        cout << "-1\n";
        return;
    }
    order.eb(unset_true_id);
    category[unset_true_id] = -3;
    for (int u : graph[unset_true_id]) {
        count_incoming[u]--;
    }
    for (int i = 0; i < n; ++i) {
        if (count_incoming[i] == 0 && is_unset_false[i] && category[i] == -1) {
            freee.emplace_back(i);
        }
    }
    while (!freee.empty()) {
        int v = freee.front();
        freee.pop_front();
        category[v] = 2;
        order.eb(v);
        for (int u : graph[v]) {
            count_incoming[u]--;
            if (is_unset_false[u]) {
                if (count_incoming[u] == 0) {
                    freee.emplace_back(u);
                }
            }
        }
    }
    if (sz(order) != n) {
        cout << "-1\n";
        return;
    }

//    for (int i = 0; i < n; ++i) {
//        if (is_set_false[i]) {
//            category[i] = 1;
//            graph[set_true_id].emplace_back(i);
//            if (unset_true_id != -1) {
//                graph[i].emplace_back(unset_true_id);
//            }
//        } else if (is_unset_false[i] && category[i] == -1) {
//            category[i] = 2;
//            if (unset_true_id == -1) {
//                cout << "-1\n";
//                return;
//            }
//            graph[unset_true_id].emplace_back(i);
//        }
//    }
//    auto ans = get_topsort(graph);
//    if (ans.empty()) {
//        cout << -1 << '\n';
//        return;
//    }
    for (auto e : order) {
        cout << e + 1 << ' ';
    }
    cout << '\n';
}