#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

pair<vector<int>, bool> build_order(vector<vector<int>> const& graph) {
	int n = szof(graph);
	vector<int> cnt(n);
	for (int i = 0; i < n; ++i) {
		for (int to : graph[i]) {
			cnt[to]++;
		}
	}

	queue<int> qu;
	for (int i = 0; i < n; ++i) {
		if (!cnt[i]) {
			qu.push(i);
		}
	}

	vector<int> res;
	while (szof(qu)) {
		int v = qu.front();
		qu.pop();
		res.push_back(v);
		for (int to : graph[v]) {
			--cnt[to];
			if (!cnt[to]) {
				qu.push(to);
			}
		}
	}

	if (szof(res) == n) {
		return {res, true};
	}
	return {{}, false};
}

void solve() {
	int n;
	cin >> n;

	vector<pii> arr;
	vector cnt(2, vector<int>(2));

	for (int i = 0; i < n; ++i) {
		string type, res;
		cin >> type >> res;
		int a = type == "set";
		int b = res == "true";
		arr.push_back({a, b});
		cnt[a][b]++;
	}
	
	int m;
	cin >> m;
	vector<vector<int>> graph(n), rgraph(n);
	vector<int> cnt_in(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		graph[a].push_back(b);
		rgraph[b].push_back(a);
		cnt_in[b]++;
	}

	function<pair<vector<int>, bool>(vector<int> const&, vector<int> const&)> add_to_order = [&](vector<int> const& start, vector<int> const& add) {
		vector<int> state(n, -2);
		for (int i = 0; i < szof(start); ++i) {
			state[start[i]] = i;
		}
		for (int ind : add) {
			state[ind] = -1;
		}

		auto cur_cnt = cnt_in;

		for (int ind : start) {
			for (int to : graph[ind]) {
				if (state[to] >= 0) {
					assert(state[ind] < state[to]);
				}
				--cur_cnt[to];
			}
		}

		for (int ind : start) {
			if (cur_cnt[ind]) {
				return pair(vector<int>(), false);
			}
		}

		queue<int> qu;
		for (int i = 0; i < n; ++i) {
			if (state[i] == -1 && !cur_cnt[i]) {
				qu.push(i);
			}
		}

		// cerr << szof(start) << " " << szof(add) << endl;

		auto ret = start;
		while (szof(qu)) {
			int v = qu.front();
			qu.pop();
			ret.push_back(v);
			for (int to : graph[v]) {
				--cur_cnt[to];
				if (state[to] == -1 && !cur_cnt[to]) {
					qu.push(to);
				}
			}
		}

		if (szof(ret) < szof(start) + szof(add)) {
			return pair(vector<int>(), false);
		}
		return pair(ret, true);
	};

	function<pair<vector<int>, bool>(vector<int> const&, vector<int> const&)> add_to_order_isolated = [&](vector<int> const& start, vector<int> const& add) {
		vector<int> state(n, -2);
		for (int i = 0; i < szof(start); ++i) {
			state[start[i]] = i;
		}
		for (int ind : add) {
			state[ind] = -1;
		}

		vector<int> cur_cnt(n);
		for (int i = 0; i < n; ++i) {
			if (state[i] != -2) {
				for (int to : graph[i]) {
					cur_cnt[to]++;
				}
			}
		}

		for (int ind : start) {
			for (int to : graph[ind]) {
				if (state[to] >= 0) {
					assert(state[ind] < state[to]);
				}
				--cur_cnt[to];
			}
		}

		for (int ind : start) {
			if (cur_cnt[ind]) {
				return pair(vector<int>(), false);
			}
		}

		queue<int> qu;
		for (int i = 0; i < n; ++i) {
			if (state[i] == -1 && !cur_cnt[i]) {
				qu.push(i);
			}
		}

		auto ret = start;
		while (szof(qu)) {
			int v = qu.front();
			qu.pop();
			ret.push_back(v);
			for (int to : graph[v]) {
				--cur_cnt[to];
				if (state[to] == -1 && !cur_cnt[to]) {
					qu.push(to);
				}
			}
		}

		if (szof(ret) < szof(start) + szof(add)) {
			return pair(vector<int>(), false);
		}
		return pair(ret, true);
	};

	auto finish_order = [&](vector<int> const& start) {
		vector<bool> used(n);
		for (int ind : start) {
			used[ind] = true;
		}
		vector<int> left;
		for (int i = 0; i < n; ++i) {
			if (!used[i]) {
				left.push_back(i);
			}
		}

		return add_to_order(start, left);
	};

	// case 1
	if (cnt[1][1] == 1 && cnt[0][0] == 0 && cnt[0][1] == 0) {
		int first = find(arr.begin(), arr.end(), pii(1, 1)) - arr.begin();
		auto [order, fl] = finish_order({first});
		if (fl) {
			for (int ind : order) {
				cout << ind + 1 << " ";
			}
			cout << "\n";
			return;
		}
	}

	// case 2
	if (cnt[1][0] == 0 && cnt[1][1] == 0 && cnt[0][1] == 0) {
		auto [order, fl] = finish_order({});
		if (fl) {
			for (int ind : order) {
				cout << ind + 1 << " ";
			}
			cout << "\n";
			return;
		}
	}

	// case 3
	if (cnt[0][1] == 1 && cnt[1][1] == 1) {
		vector<int> part1, part2, part3, part4;
		for (int i = 0; i < n; ++i) {
			if (arr[i] == pii(1, 1)) {
				part1.push_back(i);
			} else if (arr[i] == pii(1, 0)) {
				part2.push_back(i);
			} else if (arr[i] == pii(0, 1)) {
				part3.push_back(i);
			} else {
				part4.push_back(i);
			}
		}

		auto [part12, fl1] = add_to_order(part1, part2);
		if (fl1) {
			auto [part123, fl2] = add_to_order(part12, part3);
			if (fl2) {
				auto [res, fl3] = add_to_order(part123, part4);
				if (fl3) {
					for (int ind : res) {
						cout << ind + 1 << " ";
					}
					cout << "\n";
					return;
				}
			}
		}
	}

	// case 4
	if (cnt[0][1] == 0 && cnt[1][1] == 1) {
		vector<int> part1, part2, part3, part4;
		for (int i = 0; i < n; ++i) {
			if (arr[i] == pii(0, 0)) {
				part2.push_back(i);
			} else if (arr[i] == pii(1, 1)) {
				part3.push_back(i);
			} else if (arr[i] == pii(1, 0)) {
				part4.push_back(i);
			}
		}

		auto [part12, fl] = add_to_order(part1, part2);
		if (fl) {
			auto [part123, fl2] = add_to_order(part12, part3);
			if (fl2) {
				auto [res, fl3] = add_to_order(part123, part4);
				if (fl3) {
					for (int ind : res) {
						cout << ind + 1 << " ";
					}
					cout << "\n";
					return;
				}
			}
		}
	}

	// case 5
	if (cnt[0][1] == 1 && cnt[1][1] == 1) {
		vector<int> part1, part2, part3;
		for (int i = 0; i < n; ++i) {
			if (arr[i] == pii(1, 1)) {
				part1.push_back(i);
			} else if (arr[i] == pii(1, 0)) {
				part2.push_back(i);
			} else if (arr[i] == pii(0, 1)) {
				part3.push_back(i);
			}
		}

		auto [part12, fl1] = add_to_order_isolated(part1, part2);
		if (fl1) {
			auto [part123, fl2] = add_to_order_isolated(part12, part3);
			if (fl2) {
				// for (int ind : part123) {
				// 	cerr << ind + 1 << " ";
				// }
				// cerr << endl;

				vector<bool> used(n);
				for (int ind : part123) {
					used[ind] = true;
				}

				vector<int> new_ind(n);
				vector<int> rev_ind(n);
				int ind_cnt = 1;
				for (int i = 0; i < n; ++i) {
					if (used[i]) {
						new_ind[i] = 0;
					} else {
						new_ind[i] = ind_cnt;
						rev_ind[ind_cnt] = i;
						ind_cnt++;
					}
				}

				vector<vector<int>> ngraph(ind_cnt);
				for (int i = 0; i < n; ++i) {
					for (int to : graph[i]) {
						if (new_ind[i] != new_ind[to]) {
							ngraph[new_ind[i]].push_back(new_ind[to]);
						}
					}
				}

				auto [order, fl3] = build_order(ngraph);

				if (fl3) {
					for (int ind : order) {
						if (ind == 0) {
							for (int ind2 : part123) {
								cout << ind2 + 1 << " ";
							}
						} else {
							cout << rev_ind[ind] + 1 << " ";
						}
					}
					cout << "\n";
					return;
				}
			}
		}
	}

	cout << "-1\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int) 1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}