fun main() {
    val input = readln()
    val vInput = validate(input)
    check(vInput != Result.MALFORMED)
    if (vInput == Result.CORRECT) {
        println("Correct")
    } else {
        var ans: String? = null
        find@for (i in 0..<input.length) {
            if (input[i] in '0'..'9') {
                for (j in 0..<input.length) {
                    val sb = StringBuilder()
                    sb.append(input.substring(0, i))
                    sb.append(input.substring(i + 1, input.length))
                    sb.insert(j, input[i])
                    val s = sb.toString()
                    if (validate(s) == Result.CORRECT) {
                        ans = s
                        break@find
                    }
                }
            }
        }
        if (ans == null) {
            println("Impossible")
        } else {
            println(ans)
        }
    }
}

enum class Result { CORRECT, INCORRECT, MALFORMED }

fun validate(s: String): Result {
    var i = 0
    fun readNumber(): Int? {
        var j = i
        while (j < s.length && s[j] in '0'..'9') j++
        if (j == i || j > i + 1 && s[i] == '0' || j > i + 10) return null
        var num = 0
        for (k in i..<j) num = num * 10 + (s[k] - '0')
        i = j
        return num
    }
    fun readExpr(): Int? {
        var expr = readNumber() ?: return null
        while (i < s.length && (s[i] == '+' || s[i] == '-')) {
            val op = s[i++]
            val num = readNumber() ?: return null
            when (op) {
                '+' -> expr += num
                '-' -> expr -= num
            }
        }
        return expr
    }
    val expr1 = readExpr() ?: return Result.MALFORMED
    if (i >= s.length || s[i] != '=') return Result.MALFORMED
    i++
    val expr2 = readExpr() ?: return Result.MALFORMED
    return if (expr1 == expr2) Result.CORRECT else Result.INCORRECT
}