#include "fibonacci.h"

int mod;

int mult(int x, int y) {
    return (x * 1ll * y) % mod;
}

int mypow(int x, int p) {
    int cur = x;
    int ans = 1;
    while (p > 0) {
        if (p & 1) {
            ans = mult(ans, cur);
        }
        cur = mult(cur, cur);
        p >>= 1;
    }
    return ans;
}

int modInv(int x) {
    return mypow(x, mod - 2);
}

int main(int argc, char** argv) {
    registerGen(argc, argv, 1);
    mod = opt<int>("mod");

    // mod = 1000000007;

    vector<int> f;
    f.push_back(1);
    f.push_back(1);
    map<int, int> fib;
    fib[1] = 0;
    for (int i = 0; i < 100000; ++i) {
        f.push_back(f.back() + f[f.size() - 2]);
        if (f.back() > mod) {
            f.back() -= mod;
        }
        if (fib.find(f.back()) == fib.end()) {
            fib[f.back()] = f.size() - 1;
        }
    }

    int cur = 1;

    for (int i = 0; i < 128; ++i) {
        cur = mult(cur, 2);
    }

    for (auto [val1, len1] : fib) {
        int x = mult(cur, val1);
        int val2 = modInv(x);
        if (fib.find(val2) != fib.end()) {
            if (128 * 3 + len1 + 1 + fib[val2] <= 200000) {
                cout << "1\n";
                cout << 128 * 3 + len1 + 1 + fib[val2] << "\n";
                for (int s = 0; s < 2; ++s) {
                    for (int i = 0; i < 128; ++i) {
                        cout << "..#";
                    }
                    for (int i = 0; i < len1; ++i) {
                        cout << ".";
                    }
                    cout << "#";
                    for (int i = 0; i < fib[val2]; ++i) {
                        cout << ".";
                    }
                    cout << "\n";
                }
                return 0;
            }
        }
    }
    throw;
    return 0;
}