#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

int main(int argc, char* argv[])
{
    registerValidation(argc, argv);
    int n = inf.readInt(1, 50000, "n");
    inf.readEoln();
    int draws = 0;
    vector<map<vector<long long>, vector<pair<long long, long long>>>> segments(4);
    int dir = 0;
    vector<long long> cur(4);
    for (int i = 0; i < n; i++)
    {
        auto command = inf.readToken();
        if (command != "rotate" && command != "draw" && command != "move")
        {
            quitf(_fail, "Invalid command: %s", command.c_str());
        }
        inf.readSpace();
        if (command == "draw")
        {
            draws++;
        }
        if (command == "rotate")
        {
            auto angle = inf.readInt(45, 360, "d");
            if (angle % 45 != 0)
            {
                quitf(_fail, "Invalid angle: %d", angle);
            }
            dir += angle / 45;
            dir %= 8;
        }
        else
        {
            auto l = inf.readInt(1, 1000000000, "l");
            auto was = cur[dir % 4];
            cur[dir % 4] += dir >= 4 ? -l : l;
            if (command == "draw")
            {
                vector<long long> key;
                for (int j = 0; j < 4; j++)
                {
                    if (dir % 4 != j)
                    {
                        key.push_back(cur[j]);
                    }
                }
                segments[dir % 4][key].push_back(pair(min(was, cur[dir % 4]), max(was, cur[dir % 4])));
            }
        }
        inf.readEoln();
    }
    inf.readEof();
    if (draws == 0 || draws > 2000)
    {
        quitf(_fail, "Invalid number of draws: %d", draws);
    }
    for (int i = 0; i < 4; i++)
    {
        for (auto p : segments[i])
        {
            auto v = p.second;
            sort(v.begin(), v.end());
            for (int j = 1; j < v.size(); j++)
            {
                if (v[j].first < v[j - 1].second)
                {
                    quitf(_fail, "Segments intersect");
                }
            }
        }
    }
}
