#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

int ll_sign(ll num) {
	return num < 0 ? -1 : (num > 0 ? 1 : 0);
}

struct number {
	ll a, b;
	// number = a + sqrt(2) * b
	number(ll num) : a(num), b(0) {}
	number(ll a_, ll b_) : a(a_), b(b_) {}

	number operator+(number const& other) const {
		return number(a + other.a, b + other.b);
	}
	number operator-(number const& other) const {
		return number(a - other.a, b - other.b);
	}
	number operator-() const {
		return number(-a, -b);
	}
	number operator*(number const& other) const {
		return number(a * other.a + 2 * b * other.b, a * other.b + b * other.a);
	}
	number div_sqrt2() const {
		assert(a % 2 == 0);
		return number(b, a / 2);
	}

	bool operator==(number const& other) const {
		return a == other.a && b == other.b;
	}

	int sign() {
		if (a == 0 || b == 0) {
			return ll_sign(a) + ll_sign(b);
		}

		if (a < 0 && b < 0) {
			return -1;
		}
		if (a > 0 && b > 0) {
			return 1;
		}

		__int128_t a2 = __int128_t(a) * a;
		__int128_t b2 = __int128_t(b) * b * 2;

		int sign;
		// a - sqrt(2) * |b|
		if (a2 > b2) {
			sign = 1;
		} else if (a2 == b2) {
			sign = 0;
		} else {
			sign = -1;
		}

		if (a < 0) {
			sign *= -1;
		}

		return sign;
	}

	bool operator<(number const& other) const {
		return operator-(other).sign() < 0;
	}
};

struct point {
	number x, y;

	template<typename T>
	point(T x_, T y_) : x(x_), y(y_) {}

	point operator+(point const& other) {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) {
		return point(x - other.x, y - other.y);
	}

	point operator*(number const& num) {
		return point(x * num, y * num);
	}

	point rotate45() {
		return point((x - y).div_sqrt2(), (x + y).div_sqrt2());
	}

	bool operator==(point const& other) const {
		return x == other.x && y == other.y;
	}

	bool operator<(point const& other) const {
		return x < other.x || (x == other.x && y < other.y);
	}

	int dir_hash() {
		int x_sign = x.sign();
		int y_sign = y.sign();
		return (x_sign + 1) * 3 + (y_sign + 1);
	}
};

number sqrt2(0, 1);
vector<point> dirs = {point(2, 0), point(sqrt2, sqrt2), point(0, 2), point(-sqrt2, sqrt2), 
	point(-2, 0), point(-sqrt2, -sqrt2), point(0, -2), point(sqrt2, -sqrt2)};

void norm(vector<pair<point, point>>& segs) {
	for (auto& [p1, p2] : segs) {
		if (p2 < p1) {
			swap(p1, p2);
		}
	}

	sort(segs.begin(), segs.end());

	auto p = segs[0].ff;
	for (auto& [p1, p2] : segs) {
		p1 = p1 - p;
		p2 = p2 - p;
	}
}

void solve() {
	int n;
	cin >> n;
	int cur_ang = 0;
	point cur_pos(0, 0);
	vector<pair<point, point>> segs;
	for (int i = 0; i < n; ++i) {
		string s;
		int num;
		cin >> s >> num;
		if (s == "rotate") {
			cur_ang = (cur_ang + num / 45) % 8;
		} else {
			point next_pos = cur_pos + dirs[cur_ang] * num;
			if (s == "draw") {
				segs.push_back({cur_pos, next_pos});
			}
			cur_pos = next_pos;
		}
	}

	norm(segs);

	for (int i = 0; i < szof(segs); ++i) {
		for (int j = i + 1; j < szof(segs); ++j) {
			if (segs[i].ss == segs[j].ff && (segs[i].ss - segs[i].ff).dir_hash() == (segs[j].ss - segs[j].ff).dir_hash()) {
				segs[i].ss = segs[j].ss;
				segs.erase(segs.begin() + j);
				--j;
			}
		}
	}

	auto cur_segs = segs;
	for (int i = 1; i <= 8; ++i) {
		vector<pair<point, point>> next_segs;
		for (auto [p1, p2] : cur_segs) {
			next_segs.push_back({p1.rotate45(), p2.rotate45()});
		}

		cur_segs = next_segs;

		norm(cur_segs);

		if (segs == cur_segs) {
			cout << i * 45 << "\n";
			break;
		}
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int) 1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}