#include "testlib.h"

using namespace std;

using ll = long long;

const ll MAXT = 1'000'000'000'000'000;

int main(int argc, char **argv) {
  registerGen(argc, argv, 1);
  int T = opt<int>("tests");
  int totn = opt<int>("n");
  int totm = opt<int>("m");
  int totq = opt<int>("q");
  int C = opt<int>("alim");
  auto H = opt<long long>("hlim");
  auto S = opt<long long>("slim");
  auto ns = rnd.partition(T, totn);
  auto ms = rnd.partition(T, totm);
  auto qs = rnd.partition(T, totq);
  printf("%d\n", T);
  for (int i = 0; i < T; i++) {
    int n = ns[i], m = ms[i], q = qs[i];
    vector<pair<ll, int>> a(n);
    for (int i = 0; i < n; i++) {
      a[i].second = rnd.next(1, C);
      a[i].first = (i ? a[i-1].first : 0) + a[i].second;
    }
    ll tot = a.back().first;
    shuffle(a.begin(), a.end());
    printf("%d %d %d\n", n, m, q);
    for (int i = 0; i < n; i++) {
      printf("%d%c", a[i].second, " \n"[i==n-1]);
    }
    for (int i = 0; i < n; i++) {
      ll d = a[i].first + rnd.next(0LL, H);
      tot = max(tot, d);
      printf("%lld%c", min(MAXT, d), " \n"[i==n-1]);
    }
    for (int i = 0; i < m; i++) {
      int l = rnd.next(1LL, S);
      tot += l;
      printf("%d%c", l, " \n"[i==m-1]);
    }
    tot = min(tot, MAXT) + rnd.next(0LL, S);
    vector<ll> qs = rnd.distinct((int)min((ll)q, tot), 1LL, tot);
    while ((int)qs.size() < q) qs.push_back(rnd.next(1LL, tot));
    shuffle(qs.begin(), qs.end());
    for (int i = 0; i < q; i++) {
      printf("%lld%c", qs[i], " \n"[i==q-1]);
    }
  }

}
