#include "testlib.h"

/**
 * Author: Niyaz Nigmatullin
 *
 */

using namespace std;

int const MAXN = 2000;

int main(int argc, char **argv) {
	registerValidation(argc, argv);
	int t = inf.readInt(1, MAXN, "t");
	inf.readEoln();
	int totalN = 0;
	for (int test = 1; test <= t; test++) {
	    setTestCase(test);
    	int n = inf.readInt(1, MAXN, "n");
    	inf.readEoln();
    	totalN += n;
    	ensuref(totalN <= MAXN, "Total sum of 'n' in input exceeds %d", MAXN);
    	auto readPermutation = [](int n, string name) {
    		vector<int> p = inf.readInts(n, 1, n, name);
    		vector<int> used(n);
    		for (int i = 0; i < n; i++) {
    			int x = p[i] - 1;
    			ensuref(!used[x], "Not a permutation, duplicate element '%d'", p[i]);
    			used[x] = true;
     		}
     		inf.readEoln();
    	};
    	readPermutation(n, "p_1");
    	readPermutation(n, "p_2");
    	int k = inf.readInt(1, n, "k");
    	inf.readEoln();
    	auto readFiltered = [](int k, int n, string name) {
    		vector<int> p = inf.readInts(k, -1, n, name);
    		vector<int> used(n);
    		for (int i = 0; i < k; i++) {
    			if (p[i] == -1) continue;
    			ensuref(1 <= p[i] && p[i] <= n, "Expected -1 or from [1, n], found %d", p[i]);
    			int x = p[i] - 1;
    			ensuref(!used[x], "Not a filtered permutation, duplicate element '%d", p[i]);
    			used[x] = true;
    		}
    		inf.readEoln();
    	};
    	readFiltered(k, n, "s_1");
    	readFiltered(k, n, "s_2");
	}
	inf.readEof();
}
