#include <bits/stdc++.h>

using namespace std;

#ifdef DBG
#define debugf(s, ...) do { fprintf(stderr, "(" #__VA_ARGS__ "): "); \
                            fprintf(stderr, s, __VA_ARGS__);         \
                            fprintf(stderr, "\n");} while (false)
#define debugv(c, v) do { fprintf(stderr, "("#v"):\n"); int idx = 0; for (auto elem: (v)) {fprintf(stderr, "\t");debugf("%d " c, idx, elem); ++idx;}} while (false)
#else
#define debugf(...) do {} while (false)
#define debugv(...) do {} while (false)
#endif

using i64 = int64_t;

int mod = 998'244'353;

#define CE /*constexpr*/

struct imt {
    int val = 0;
    CE imt() = default;

    CE imt(int x) : val(x < 0 ? x + mod : x) {
    }

    template<typename Num>
    CE imt(Num x) : val(int(x % mod)) {
    }

    CE imt &operator+=(imt x) {
        val += x.val;
        if (val >= mod) val -= mod;
        return *this;
    }

    CE imt &operator-=(imt x) {
        val -= x.val;
        if (val < 0) val += mod;
        return *this;
    }

    CE imt &operator*=(imt x) {
        val = val * 1LL * x.val % mod;
        return *this;
    }

    CE friend imt operator+(imt x, imt y) {
        return x += y;
    }

    CE friend imt operator-(imt x, imt y) {
        return x -= y;
    }

    CE friend imt operator*(imt x, imt y) {
        return x *= y;
    }

    CE imt pow(i64 x) const {
        x %= (mod - 1);
        if (x < 0) {
            x += mod - 1;
        }
        imt cur = *this;
        imt res = 1;
        while (x > 0) {
            if (x & 1) res *= cur;
            cur *= cur;
            x >>= 1;
        }
        return res;
    }

    CE imt inv() const {
        return pow(mod - 2);
    }

    CE imt &operator/=(imt x) {
        return operator*=(x.inv());
    }

    CE friend imt operator/(imt x, imt y) {
        return x /= y;
    }
};


template <typename Num>
struct edge {
    int u, v;
    Num f, c;
    int mark = -1;
};

template <typename Num>
Num dinics_dfs(
        const vector<basic_string<int>> &g, const vector<int> &dist, int s, int u, Num so_far,
        vector<edge<Num>> &edges, vector<int> &ind
        ) {
    if (u == s) return so_far;
    while (ind[u] < g[u].size()) {
        auto &pe = edges[g[u][ind[u]]];
        int v = pe.u == u ? pe.v : pe.u;

        if (dist[v] != dist[u] - 1) ++ind[u];
        else if (Num exc = u == pe.u ? pe.f : pe.c - pe.f; exc == 0) ++ind[u];
        else if (Num res = dinics_dfs(g, dist, s, v, min(so_far, exc), edges, ind); res == 0) ++ind[u];
        else {
            pe.f += u == pe.u ? -res : res;
            return res;
        }
    }
    return Num(0);
}

template <typename Num>
Num dinics(const vector<basic_string<int>> &g, vector<edge<Num>> &edges, int s, int t) {
    int n = g.size();
    Num res = 0, local_res;

    do {
        vector<int> dist(n, -1), ind(n);

        deque<int> q{s};
        dist[s] = 0;
        while (!q.empty()) {
            int u = q.front();
            q.pop_front();
            for (auto idx: g[u]) {
                auto &e = edges[idx];
                int v = e.u == u ? e.v : e.u;
                if (((u == e.u && e.f < e.c) || (u == e.v && e.f > 0)) && dist[v] == -1) {
                    dist[v] = dist[u] + 1;
                    q.push_back(v);
                }
            }
        }
        if (dist[t] == -1) break;
        do res += (local_res = dinics_dfs(g, dist, s, t, numeric_limits<Num>::max(), edges, ind));
        while (local_res);
    } while (true);
    return res;
}

struct record {
    set<int> available;
    int to_take;
};

using et = edge<int>;

void solve(int tcc) {

    int n;
    cin >> n;

    vector<int> p(n), q(n), ip(n), iq(n);

    for (auto &e: p) {
        cin >> e;
        --e;
    }

    for (auto &e: q) {
        cin >> e;
        --e;
    }

    for (int i = 0; i < n; ++i) {
        ip[p[i]] = i;
        iq[q[i]] = i;
    }

    int k;
    cin >> k;

    vector<int> a(k), b(k);

    for (auto &e: a) {
        cin >> e;
        --e;
    }

    for (auto &e: b) {
        cin >> e;
        --e;
    }

    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < i; ++j) {
            if (a[i] != -2 && a[j] != -2 && ip[a[i]] < ip[a[j]]) {
                cout << "Inconsistent\n";
                return;
            }
            if (b[i] != -2 && b[j] != -2 && iq[b[i]] < iq[b[j]]) {
                cout << "Inconsistent\n";
                return;
            }
        }
    }

    vector<record> ar, br;

    {
        int last = -1;
        for (int i = 0; i < k; ++i) {
            if (a[i] == -2) continue;
            if (i - last > 1) {
                record r;
                r.to_take = i - last - 1;
                for (int j = last == -1 ? 0 : ip[a[last]] + 1; j < ip[a[i]]; ++j) {
                    r.available.insert(p[j]);
                }
                ar.push_back(r);
            }
            last = i;
            ar.emplace_back(set{a[i]}, 1);
        }
        if (k - last - 1 > 0) {
            record r;
            r.to_take = k - last - 1;
            for (int j = last == -1 ? 0 : ip[a[last]] + 1; j < n; ++j) {
                r.available.insert(p[j]);
            }
            ar.push_back(r);
        }
    }
    {
        int last = -1;
        for (int i = 0; i < k; ++i) {
            if (b[i] == -2) continue;
            if (i - last > 1) {
                record r;
                r.to_take = i - last - 1;
                for (int j = last == -1 ? 0 : iq[b[last]] + 1; j < iq[b[i]]; ++j) {
                    r.available.insert(q[j]);
                }
                br.push_back(r);
            }
            last = i;
            br.emplace_back(set{b[i]}, 1);
        }
        if (k - last - 1 > 0) {
            record r;
            r.to_take = k - last - 1;
            for (int j = last == -1 ? 0 : iq[b[last]] + 1; j < n; ++j) {
                r.available.insert(q[j]);
            }
            br.push_back(r);
        }
    }

    int N = ar.size() + br.size() + 2;
    int t = N - 1;
    int s = t - 1;

    vector<basic_string<int>> g(N);
    vector<et> edges;

    auto add_edge = [&] (int from, int to, int cap, int mark) {
        g[from].push_back(edges.size());
        g[to].push_back(edges.size());
        edges.emplace_back(from, to, 0, cap, mark);
    };

    for (int i = 0; i < ar.size(); ++i) {
        add_edge(s, i, ar[i].to_take, -1);
    }

    for (int i = 0; i < br.size(); ++i) {
        add_edge(ar.size() + i, t, br[i].to_take, -1);
    }

    for (int i = 0; i < n; ++i) {

        auto pred = [&](const auto &it) {return it.available.contains(i);};
        auto ai = ranges::find_if(ar, pred) - ar.begin();
        auto bi = ranges::find_if(br, pred) - br.begin();

        if (ai == ar.size() || bi == br.size()) continue;

        add_edge(ai, bi + ar.size(), 1, i);
    }

    auto res = dinics(g, edges, s, t);

    if (res != k) {
        cout << "Inconsistent\n";
        return;
    }

    string ans(n, 'N');


    for (auto &e: edges) {
        int x = e.mark;
        if (x == -1) continue;

        if (e.f) {
            int fin = e.v;
            int sta = e.u;

            vector<bool> used(2 * n);
            auto dfs = [&](auto &&self, int cur) -> bool {
                if (cur == sta) return true;
                used[cur] = true;
                for (auto idx: g[cur]) {
                    auto &ce = edges[idx];
                    if (ce.mark == -1) continue;
                    int other = ce.u == cur ? ce.v : ce.u;
                    if ((ce.u == cur && ce.f > 0) || (ce.v == cur && ce.f < ce.c)) {
                        if (!used[other]) {
                            if (self(self, other)) {
                                return true;
                            }
                        }
                    }
                }
                return false;
            };

            if (dfs(dfs, fin)) {
                ans[x] = '?';
            } else {
                ans[x] = 'Y';
            }
        } else {
            int fin = e.v;
            int sta = e.u;

            vector<bool> used(2 * n);
            auto dfs = [&](auto &&self, int cur) -> bool {
                if (cur == sta) return true;
                used[cur] = true;
                for (auto idx: g[cur]) {
                    auto &ce = edges[idx];
                    if (ce.mark == -1) continue;
                    int other = ce.u == cur ? ce.v : ce.u;
                    if ((ce.u == cur && ce.f < ce.c) || (ce.v == cur && ce.f > 0)) {
                        if (!used[other]) {
                            if (self(self, other)) {
                                return true;
                            }
                        }
                    }
                }
                return false;
            };

            if (dfs(dfs, fin)) {
                ans[x] = '?';
            } else {
                ans[x] = 'N';
            }
        }
    }

    cout << ans << '\n';



}

signed main() {
#ifndef DBG
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
#endif
    int t = 1;
    cin >> t;
    for (int i = 0; i < t; ++i) solve(i);
}
