#include <bits/stdc++.h>
using namespace std;

using ll = int64_t;

void solve(){
	int W, H;
	cin >> W >> H;
	vector<tuple<int,int,int,int,int,int> > rects(2);
	ll W_period = 2;
	ll H_period = 2;
	for(int i = 0; i < 2; i++){
		int w, h, x, y, dx, dy;
		cin >> w >> h >> x >> y >> dx >> dy;
		rects[i] = {w, h, x, y, dx, dy};
		W_period *= (W - w);
		H_period *= (H - h);
	}
	vector<int> w_intersect(W_period, 0);
	vector<int> h_intersect(H_period, 0);
	{
		auto [w0, h0, x0, y0, dx0, dy0] = rects[0];
		auto [w1, h1, x1, y1, dx1, dy1] = rects[1];
		for(int i = 0; i < W_period; i++){
			if(max(x0, x1) < min(x0 + w0, x1 + w1)){
				w_intersect[i] = 1;
			}
			x0 += dx0;
			x1 += dx1;
			if(x0 == 0 || x0 == W - w0){
				dx0 = -dx0;
			}
			if(x1 == 0 || x1 == W - w1){
				dx1 = -dx1;
			}
		}
		assert((tuple<int,int,int,int,int,int>{w0, h0, x0, y0, dx0, dy0} == rects[0]));
		assert((tuple<int,int,int,int,int,int>{w1, h1, x1, y1, dx1, dy1} == rects[1]));
	}
	{
		auto [w0, h0, x0, y0, dx0, dy0] = rects[0];
		auto [w1, h1, x1, y1, dx1, dy1] = rects[1];
		for(int i = 0; i < H_period; i++){
			if(max(y0, y1) < min(y0 + h0, y1 + h1)){
				h_intersect[i] = 1;
			}
			y0 += dy0;
			y1 += dy1;
			if(y0 == 0 || y0 == H - h0){
				dy0 = -dy0;
			}
			if(y1 == 0 || y1 == H - h1){
				dy1 = -dy1;
			}
		}
		assert((tuple<int,int,int,int,int,int>{w0, h0, x0, y0, dx0, dy0} == rects[0]));
		assert((tuple<int,int,int,int,int,int>{w1, h1, x1, y1, dx1, dy1} == rects[1]));
	}
	ll g = gcd(W_period, H_period);
	ll tot = W_period * H_period / g;
	ll ans = 0;
	for(int r = 0; r < g; r++){
		int nx = 0;
		int ny = 0;
		for(int x = r; x < W_period; x += g){
			nx += w_intersect[x];
		}
		for(int y = r; y < H_period; y += g){
			ny += h_intersect[y];
		}
		ans += ll(nx) * ll(ny);
	}
	ll ans_g = gcd(ans, tot);
	cout << ans / ans_g << '/' << tot / ans_g << '\n';
}

int main(){
	ios_base::sync_with_stdio(false), cin.tie(nullptr);
	int T;
	cin >> T;
	while(T--) solve();
}
