//  Nikita Golikov, 2023

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

void solveTest() {
  int n; cin >> n;
  vector<int> a(2 * n);
  for (int i = 0; i < 2 * n; ++i) {
    cin >> a[i];
    --a[i];
  }
  vector<vector<int>> graph(2 * n);
  for (int i = 0; i < 2 * n - 1; ++i) {
    int u, v;
    cin >> u >> v;
    --u, --v;
    graph[u].push_back(v);
    graph[v].push_back(u);
  }
  vector<pair<int, int>> ans;
  auto dfs1 = [&](auto self, int v, int p = -1) -> bool {
    bool used = false;
    for (int u : graph[v]) {
      if (u == p) {
        continue;
      }
      auto res = self(self, u, v);
      if (!res && !used) {
        used = true;
        ans.emplace_back(u, v);
      }
    }
    return used;
  };
  dfs1(dfs1, 0);
  vector<bool> used(2 * n);
  for (auto[u, v] : ans) {
    used[u] = used[v] = true;
  }
  int last = -1;
  for (int v = 0; v < 2 * n; ++v) {
    if (!used[v]) {
      if (last < 0) {
        last = v;
      } else {
        ans.emplace_back(last, v);
        last = -1;
      }
    }
  }
  vector<set<int>> pos(n);
  vector<int> bro(2 * n);
  for (int i = 0; i < 2 * n; ++i) {
    pos[a[i]].insert(i);
  }
  for (int i = 0; i < n; ++i) {
    bro[ans[i].first] = ans[i].second;
    bro[ans[i].second] = ans[i].first;
  }
  used.assign(2 * n, false);
  auto other = [&](int val, int position) {
    if (*pos[val].begin() != position) return *pos[val].begin();
    assert(*pos[val].rbegin() != position);
    return *pos[val].rbegin();
  };
  vector<bool> inSwap(2 * n);
  vector<pair<int, int>> swaps;
  auto dfs = [&](auto self, int v) -> void {
    used[v] = true;
    if (a[v] == a[bro[v]]) {
      used[bro[v]] = true;
      return;
    }
    int whoSwap = bro[v];
    int withSwap = other(a[v], v);
    assert(!inSwap[whoSwap]);
    assert(!inSwap[withSwap]);
    inSwap[whoSwap] = inSwap[withSwap] = true;
    swaps.emplace_back(whoSwap, withSwap);
    pos[a[whoSwap]].erase(whoSwap);
    pos[a[withSwap]].erase(withSwap);
    swap(a[whoSwap], a[withSwap]);
    pos[a[whoSwap]].insert(whoSwap);
    pos[a[withSwap]].insert(withSwap);
    used[bro[v]] = true;
    self(self, withSwap);
  };
  for (int v = 0; v < 2 * n; ++v) {
    if (!used[v]) {
      dfs(dfs, v);
    }
  }
  cout << swaps.size() << "\n";
  for (auto[u, v] : swaps) {
    cout << u + 1 << " " << v + 1 << "\n";
  }
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int tests_;
  cin >> tests_;
  for (int tt_ = 1; tt_ <= tests_; ++tt_) {
    solveTest();
  }

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
