#include <bits/stdc++.h>
using namespace std;

const int MAXN = 2e5 + 100;
vector<int> g[MAXN];
vector<array<int, 2>> match;
bool is_cov[MAXN];

int used[MAXN];
int xr[MAXN];

bool dfs(int v, int p = -1) {
    int son = -1;
    for (int u : g[v]) {
        if (u == p) continue;
        if (dfs(u, v)) son = u;
    }
    if (son == -1) {
        return true;
    }
    match.push_back({v, son});
    is_cov[v] = is_cov[son] = true;
    xr[v] ^= son;
    xr[son] ^= v;
    return false;
}

void solve_() {
    int n;
    cin >> n;
    n *= 2;
    vector<int> col(n);
    for (int i = 0; i < n; ++i) {
        cin >> col[i];
        g[i].clear();
    }
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    fill(is_cov, is_cov + n, 0);
    fill(used, used + n, 0);
    fill(xr, xr + n, 0);
    match.clear();
    dfs(0);
    vector<int> last(n, -1);
    for (int i = 0; i < n; ++i) {
        if (last[col[i]] != -1) {
            xr[i] ^= last[col[i]];
            xr[last[col[i]]] ^= i;
        }
        last[col[i]] = i;
    }
    vector<array<int, 2>> ans;
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        if (is_cov[i]) {
            continue;
        }
        vector<int> path;
        int v = xr[i];
        int pr = i;
        path.push_back(pr);
        path.push_back(v);
        used[pr] = used[v] = true;
        while (is_cov[v]) {
            int u = xr[v] ^ pr;
            pr = v;
            v = u;
            path.push_back(v);
            used[v] = true;
        }
        for (int j = 1; j < path.size() - j; ++j) {
            ans.push_back({path[j], path[path.size() - j]});
        }
    }
    for (auto elem : match) {
        int v = elem[0], pr = elem[1];
        if (used[v]) continue;
        vector<int> path;
        int start = pr;
        path.push_back(v);
        used[v] = true;
        while (v != start) {
            int u = xr[v] ^ pr;
            pr = v;
            v = u;
            path.push_back(v);
            used[v] = true;
        }
        for (int j = 1; j < path.size() - j; ++j) {
            ans.push_back({path[j], path[path.size() - j]});
        }
    }
    cout << ans.size() << "\n";
    for (auto elem : ans) {
        cout << elem[0] + 1 << " " << elem[1] + 1 << "\n";
    }
}

#define MULTITEST

signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
    int tst = 1;
#ifdef MULTITEST
    cin >> tst;
#endif // MULTITEST
    while (tst--) {
        solve_();
    }
    return 0;
}